package kaka.cakelight.mode;

import kaka.cakelight.Color;
import kaka.cakelight.LedFrame;
import kaka.cakelight.util.SimplexNoise3D;

public class TwoColorNoiseMode extends AmbientMode {
    private final Color primary, secondary;
    private SimplexNoise3D noise = new SimplexNoise3D(0);

    public TwoColorNoiseMode(Color primary, Color secondary) {
        this.primary = primary;
        this.secondary = secondary;
    }

    @Override
    protected void updateFrame(LedFrame frame, long time, int count) {
        for (int i = 0; i < config.leds.getCount(); i++) {
            double x = frame.xOf(i);
            double y = frame.yOf(i);
            double v = Math.pow(Math.min(1, Math.max(0, noise.getr(0.0, 1.0, 1, x, y, time / 7000.0))), 1.5);
            frame.setLedColor(i, primary.interpolate(secondary, v));
        }
    }
}
